﻿@using System.Web.UI.WebControls;
@using DevExpress.Web.Mvc;
@using DevExpress.Web.Mvc.UI;
@using DevExpress.Utils;
@Html.DevExpress().GridView(
grid =>    {
    
    grid.Name = "gridpocreation";
    grid.Width = Unit.Percentage(100);
    grid.Height = Unit.Percentage(100);
    grid.Settings.ShowFilterRow = true;
    grid.Settings.ShowFilterRowMenu = true;
    grid.Settings.ShowColumnHeaders = true;

    grid.CallbackRouteValues = new { Controller = "D31202", Action = "SectionGrid" };
    grid.ClientSideEvents.BeginCallback = "OnBeginCallbackGrid";
    grid.ClientSideEvents.EndCallback = "OnEndCallbackGrid";
    grid.SettingsBehavior.AllowSelectSingleRowOnly = false;
    grid.SettingsBehavior.AllowSelectByRowClick = true;
    grid.KeyFieldName = "PR_NUMBER;STATUS";
    grid.Settings.HorizontalScrollBarMode = ScrollBarMode.Visible;
    grid.Settings.VerticalScrollBarMode = ScrollBarMode.Hidden;
    grid.Styles.Header.HorizontalAlign = HorizontalAlign.Center;
    grid.Styles.Header.VerticalAlign = VerticalAlign.Middle;

    grid.SettingsPager.FirstPageButton.Visible = true;
    grid.SettingsPager.LastPageButton.Visible = true;
    grid.SettingsPager.ShowNumericButtons = true;
    grid.SettingsPager.Position = PagerPosition.Bottom;
    grid.SettingsPager.PageSizeItemSettings.Visible = true;
    grid.SettingsPager.PageSizeItemSettings.Items = new string[] { "10", "30", "50", "100" };
    grid.SettingsPager.PageSizeItemSettings.Caption = "Page size";

    grid.CommandColumn.Visible = true;
    grid.CommandColumn.Width = Unit.Pixel(40);
    grid.CommandColumn.ClearFilterButton.Visible = true;
    grid.CommandColumn.ShowSelectCheckbox = true;


    grid.CustomJSProperties = (s, e) =>
    {
        MVCxGridView gridSetting = (MVCxGridView)s;
        int startIndex = gridSetting.PageIndex * gridSetting.SettingsPager.PageSize;
        int end = Math.Min(gridSetting.VisibleRowCount, startIndex + gridSetting.SettingsPager.PageSize);
        //--=== List object
        object[] STATUS = new object[end - startIndex];

        for (int n = startIndex; n < end; n++)
        {
            STATUS[n - startIndex] = gridSetting.GetRowValues(n, "STATUS");
            

        }
        e.Properties["cpSTATUS"] = STATUS;


        gridSetting.JSProperties["cpStart"] = startIndex;
        gridSetting.JSProperties["cpEnd"] = end;
        gridSetting.JSProperties["cpPageSize"] = grid.SettingsPager.PageSize;
    };
    
    grid.Columns.Add(
        columnPO =>
        {
            columnPO.Name = "PO_NUMBER";
            columnPO.FieldName = "PO_NUMBER";
            columnPO.Caption = "PO Number";
            columnPO.PropertiesEdit.NullDisplayText = "";
            columnPO.Width = Unit.Pixel(100);
            columnPO.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
            columnPO.CellStyle.HorizontalAlign = HorizontalAlign.Center;
            columnPO.CellStyle.VerticalAlign = VerticalAlign.Middle;
            
            
            

            columnPO.SetDataItemTemplateContent(
                content =>
                {
                    GridViewDataItemTemplateContainer c = (GridViewDataItemTemplateContainer)content;
                    Html.DevExpress().HyperLink(
                        link =>
                        {
                            link.Name = "lnkPO_NO" + content.VisibleIndex;
                            link.NavigateUrl = "javascript:void(0)";
                            if (content.Text == "&nbsp;")
                            {
                                link.Properties.Text = "N/A";
                          
                            }
                            else
                            {
                                link.Properties.Text = content.Text;
                            }
                            link.ClientVisible = true;
                            link.Properties.ClientSideEvents.Click = string.Format("function(s, e) {{ OnPOClick('{0}'); }}", (content as GridViewDataItemTemplateContainer).Text);

                        }).Render();
                });
        });


    grid.Columns.Add(
        pomonth =>
        {
            pomonth.Name = "PRODUCTION_MONTH";
            pomonth.FieldName = "PRODUCTION_MONTH";
            pomonth.Caption = "Production <br /> Month";

            pomonth.Width = Unit.Pixel(80);
            pomonth.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
            pomonth.CellStyle.HorizontalAlign = HorizontalAlign.Center;
            pomonth.CellStyle.VerticalAlign = VerticalAlign.Middle;
        });
    grid.Columns.AddBand(
        columnBand =>
        {
            columnBand.Caption = "Trucking";
            columnBand.Name = "TRUCKING";
            columnBand.Columns.Add(
                potrucking =>
                {
                    potrucking.Name = "CODE";
                    potrucking.FieldName = "CODE";
                    potrucking.Caption = "Code";

                    potrucking.Width = Unit.Pixel(50);
                    potrucking.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    potrucking.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                    potrucking.CellStyle.VerticalAlign = VerticalAlign.Middle;
                });

            columnBand.Columns.Add(
            potrucking =>
            {
                potrucking.Name = "LOG_PARTNER_NAME";
                potrucking.FieldName = "LOG_PARTNER_NAME";
                potrucking.Caption = "Name";

                potrucking.Width = Unit.Pixel(210);
                potrucking.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                potrucking.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                potrucking.CellStyle.VerticalAlign = VerticalAlign.Middle;
            });
        });
    grid.Columns.Add(
        poroute =>
        {
            poroute.Name = "TOTAL_ROUTE";
            poroute.FieldName = "TOTAL_ROUTE";
            poroute.Caption = "Total<br />PO Route";

            poroute.Width = Unit.Pixel(65);
            poroute.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
            poroute.CellStyle.HorizontalAlign = HorizontalAlign.Center;
            poroute.CellStyle.VerticalAlign = VerticalAlign.Middle;
        });
    grid.Columns.Add(
        pounprocess=>
        {
            pounprocess.Name = "REMAINING_ROUTE";
            pounprocess.FieldName = "REMAINING_ROUTE";
            pounprocess.Caption = "Remaining  <br /> Unprocessed Route";
            pounprocess.Width = Unit.Pixel(120);
            pounprocess.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
            pounprocess.CellStyle.HorizontalAlign = HorizontalAlign.Center;
            pounprocess.CellStyle.VerticalAlign = VerticalAlign.Middle;
        });

    grid.Columns.Add(
    columnPR =>
    {
        columnPR.Name = "PR_NUMBER";
        columnPR.FieldName = "PR_NUMBER";
        columnPR.Caption = "PR Number";

        columnPR.Width = Unit.Pixel(100);
        columnPR.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        columnPR.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        columnPR.CellStyle.VerticalAlign = VerticalAlign.Middle;
        columnPR.PropertiesEdit.NullDisplayText = "";
        
        columnPR.SetDataItemTemplateContent(
            content =>
            {
                if (content.Text != "&nbsp;")
                {

                    GridViewDataItemTemplateContainer c = (GridViewDataItemTemplateContainer)content;
                    Html.DevExpress().HyperLink(
                        link =>
                        {
                            link.Name = "lnkPR_NO" + content.VisibleIndex;
                            link.Properties.NullDisplayText = "NA";
                            link.NavigateUrl = "javascript:void(0)";
                            link.Properties.Text = content.Text;
                            link.ClientVisible = true;
                            link.Properties.ClientSideEvents.Click = string.Format("function(s, e) {{ OnPRClick('{0}'); }}", (content as GridViewDataItemTemplateContainer).Text);

                        }).Render();
                }
            });
    });

    grid.Columns.Add(column =>
    {
        column.Name = "STATUS";
        column.Caption = "Status";
        column.FieldName = "STATUS";
        column.Width = Unit.Pixel(110);
        column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        column.CellStyle.VerticalAlign = VerticalAlign.Middle;        
        column.UnboundType = DevExpress.Data.UnboundColumnType.String;
    });
    
    //-------[ PR STATUS BEGIN ]--------
    grid.Columns.AddBand(
        pocreated =>
        {
            pocreated.Caption = "Created";
            pocreated.Columns.Add(
                createby =>
                {
                    //createby.Settings.ShowFilterRowMenu = DefaultBoolean.False;
                    //createby.Settings.AllowAutoFilter = DefaultBoolean.False;
                    createby.Caption = "By";
                    createby.Name = "CREATE_BY";
                    createby.FieldName = "CREATE_BY";
                    createby.Width = Unit.Pixel(140);
                    createby.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    createby.CellStyle.VerticalAlign = VerticalAlign.Middle;
                    createby.CellStyle.HorizontalAlign = HorizontalAlign.Left;
              });

            pocreated.Columns.Add(
                createdate =>
                {
                    //createdate.Settings.ShowFilterRowMenu = DefaultBoolean.False;
                    //createdate.Settings.AllowAutoFilter = DefaultBoolean.False;
                    createdate.Caption = "Date";
                    createdate.Name = "CREATE_DT";
                    createdate.FieldName = "CREATE_DT";
                    createdate.Width = Unit.Pixel(120);
                    createdate.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    createdate.CellStyle.VerticalAlign = VerticalAlign.Middle;
                    createdate.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                    createdate.ColumnType = MVCxGridViewColumnType.DateEdit;        
                    createdate.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";
                    var dateEditProperties = createdate.PropertiesEdit as DateEditProperties;
                    dateEditProperties.EditFormatString = "dd.MM.yyyy HH:mm";
                    dateEditProperties.UseMaskBehavior = true;
                    
                                
                });

       });

    grid.Columns.AddBand(
        pochanged =>
        {
            pochanged.Caption = "Changed";
            pochanged.Columns.Add(
                changedby =>
                {
                    //changedby.Settings.ShowFilterRowMenu = DefaultBoolean.False;
                    //changedby.Settings.AllowAutoFilter = DefaultBoolean.False;
                    changedby.Caption = "By";
                    changedby.Name = "CHANGE_BY";
                    changedby.FieldName = "CHANGE_BY";
                    changedby.Width = Unit.Pixel(140);
                    changedby.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    changedby.CellStyle.VerticalAlign = VerticalAlign.Middle;
                    changedby.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                });

            pochanged.Columns.Add(
                changeddate =>
                {
                    //changeddate.Settings.ShowFilterRowMenu = DefaultBoolean.False;
                    //changeddate.Settings.AllowAutoFilter = DefaultBoolean.False;
                    changeddate.Caption = "Date";
                    changeddate.Name = "CHANGE_DT";
                    changeddate.FieldName = "CHANGE_DT";
                    changeddate.Width = Unit.Pixel(120);
                    changeddate.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    changeddate.CellStyle.VerticalAlign = VerticalAlign.Middle;
                    changeddate.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                    changeddate.ColumnType = MVCxGridViewColumnType.DateEdit;                  
                    changeddate.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";
                      
                });


        });

    grid.HtmlDataCellPrepared = (SendMailErrorEventArgs, e) =>
    {
        if (e.DataColumn.FieldName == "PO_NUMBER")
        {
            if (e.CellValue != null)
            {
                e.Cell.BackColor = System.Drawing.Color.White;
            }
            else {
                e.Cell.BackColor = System.Drawing.Color.Yellow;
            }
        }

        if (e.DataColumn.FieldName == "REMAINING_ROUTE")
        {
            
            if (e.CellValue.ToString()!="0")
            {

                e.Cell.BackColor = System.Drawing.Color.Red;
                e.Cell.ForeColor = System.Drawing.Color.White;
            }
            
        }
    };

    
    
}).Bind(Model.GetModel<Portal.Models.Delivery.PurchaseOrder.MainModel>().MainDatas).GetHtml()

                    
                     